import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_identifier = {__proto__:null,true:58, false:58, nil:60};
const parser = LRParser.deserialize({
  version: 14,
  states: "$tQYQPOOOOQO'#C_'#C_OOQO'#C`'#C`OOQO'#Ca'#CaOOQO'#Cb'#CbO}QPO'#CgO!UQPO'#CjO!]QPO'#CmO!dQPO'#CoO!kQPO'#CqOOQO'#Cv'#CvOOQO'#Cr'#CrQYQPOOOOQO,59R,59RO!rQPO,59ROOQO,59U,59UO!yQPO,59UOOQO,59X,59XO#QQPO,59XOOQO,59Z,59ZO#XQPO,59ZOOQO,59],59]O#`QPO,59]OOQO-E6p-E6pOOQO1G.m1G.mOOQO1G.p1G.pOOQO1G.s1G.sOOQO1G.u1G.uOOQO1G.w1G.w",
  stateData: "#g~OiOSPOS~OVYOWYOYTO]UO`VObWOdXOkPOlQOmROnSO~OX]O~PYO[_O~PYO_aO~PYO[cO~PYO_eO~PYOXhO~PYO[iO~PYO_jO~PYO[kO~PYO_lO~PYO",
  goto: "!tkPPPllllPPPPlPPlPPlPlPlzPPP!fiYOTUVWX[^`bdfQ[OQ^TQ`UQbVQdWQfX]g[^`bdfiZOTUVWX[^`bdf",
  nodeNames: "⚠ LineComment Program Identifier Number Boolean Nil String Keyword ) ( Form ] [ Tuple } { Struct @[ Array @{ Table",
  maxTerm: 30,
  nodeProps: [
    ["openedBy", 9,"(",12,"[ @[",15,"{ @{"],
    ["closedBy", 10,")",-2,13,18,"]",-2,16,20,"}"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: ",d~RoXY#SYZ#S]^#Spq#Sqr#ers$ust%dtu#evw#exy%oyz%tz{#e{|%y}!O%y!O!P%y!P!Q#e!Q![']![!]'n!^!_#e!_!`#e!`!a#e!b!c*^!c!}#e!}#O,O#P#Q,T#Q#R#e#R#S#e#T#o#e#o#p,Y#p#q#e#q#r,_~#XSi~XY#SYZ#S]^#Spq#S~#jck~qr#etu#evw#ez{#e{|#e}!O#e!O!P#e!P!Q#e!Q![#e![!]#e!^!_#e!_!`#e!`!a#e!b!c#e!c!}#e#Q#R#e#R#S#e#T#o#e#p#q#e~$xTOr$urs%Xs#O$u#O#P%^#P~$u~%^OV~~%aPO~$u~%iQP~OY%dZ~%d~%tOY~~%yOX~~&Qcl~k~qr#etu#evw#ez{#e{|%y}!O%y!O!P%y!P!Q#e!Q![%y![!]#e!^!_#e!_!`#e!`!a#e!b!c#e!c!}#e#Q#R#e#R#S#e#T#o#e#p#q#e~'bSl~{|']}!O']!O!P']!Q![']~'qcqr(|tu(|vw(|z{(|{|(|}!O(|!O!P(|!P!Q(|!Q![(|![!](|!^!_(|!_!`(|!`!a(|!b!c(|!c!}(|#Q#R(|#R#S(|#T#o(|#p#q(|~)RcW~qr(|tu(|vw(|z{(|{|(|}!O(|!O!P(|!P!Q(|!Q![(|![!](|!^!_(|!_!`(|!`!a(|!b!c(|!c!}(|#Q#R(|#R#S(|#T#o(|#p#q(|~*cek~qr#etu#evw#ez{#e{|#e}!O#e!O!P#e!P!Q#e!Q![#e![!]#e!^!_#e!_!`#e!`!a#e!b!c#e!c!}#e!}#O+t#Q#R#e#R#S#e#T#o#e#o#p+y#p#q#e~+yOb~~,OOd~~,TO]~~,YO[~~,_O`~~,dO_~",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  specialized: [{term: 27, get: value => spec_identifier[value] || -1}],
  tokenPrec: 0
});

const JanetLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Form: delimitedIndent({ closing: ")", align: false }),
                Tuple: delimitedIndent({ closing: "]", align: false }),
                Array: delimitedIndent({ closing: "]", align: false }),
                Struct: delimitedIndent({ closing: "}", align: false }),
                Table: delimitedIndent({ closing: "}", align: false }),
            }),
            foldNodeProp.add({
                Form: foldInside,
                Tuple: foldInside,
                Array: foldInside,
                Struct: foldInside,
                Table: foldInside,
            }),
            styleTags({
                Identifier: tags.name,
                Boolean: tags.bool,
                Number: tags.number,
                String: tags.string,
                LineComment: tags.lineComment,
                Nil: tags.null,
                Keyword: tags.atom,
                "( )": tags.paren,
                "@[ [ ]": tags.squareBracket,
                "@{ { }": tags.brace,
            })
        ]
    }),
    languageData: {
        commentTokens: { line: "#" },
        closeBrackets: {
            brackets: ['(', '[', '{', '"', '`']
        },
    }
});
function janet() {
    return new LanguageSupport(JanetLanguage);
}

export { JanetLanguage, janet };
